#include "defs.inc"
  ORG START_ADDR
; 0xCB7F  => BC=crc

;CALL FS_FNDF ; DE - name of file for finding, out HL - string FAT record of file
;CALL F_OPEN ; DE - name of file for opening, out C==1 if file not founded
;CALL F_READ ; HL - addr for store readed data, BC - size of readed data


#ifdef RK86
#ifdef SD_ROM
#else
  jmp 0f800H
  nop
#endif
#endif

ENTRY:
#ifdef MX2
  call 0c84eH  ;   
#endif
  lxi h,BUF
  lxi b,2048-256
clrmem:
  mvi m,0
  inx h
  dcx b
  mov a,c
  ora b
  jnz clrmem
  CALL FS_RST
LOOP:
;  LXI SP,066cf
  MVI C,20H
  LXI H,LINEBUF
LOOP0:
  mvi m,0
  inx h
  DCR C
  JNZ LOOP0
  LXI H,A_DRIVE
  CALL PRINT
  LXI H,CWD
  CALL PRINT
  MVI C,'>'
  CALL PUTC
  CALL READLN
  LXI H,LOOP
  PUSH H
  LXI H,CMDLST
LOOP1:  MOV A,M
  ORA A
  JZ RUNFILE
  LXI D,LINEBUF
LOOP2:  MOV A,M
  ORA A
  JZ LOOP3
  LDAX D
  CMP M
  JNZ LOOP4
  INX D
  INX H
  JMP LOOP2
LOOP3:  LDAX D
  ORA A
  JZ LOOP5
  CPI 20H
  JZ LOOP5
LOOP4:  MOV A,M
  INX H
  ORA A
  JNZ LOOP4
  INX H
  INX H
  JMP LOOP1
LOOP5:  INX H
  MOV E,M
  INX H
  MOV D,M
  LXI H,NEWLINE
  CALL PRINT
  XCHG
  PCHL

PRINTN: MOV C,M
  INX H
  CALL PUTC
  DCR B
  JNZ PRINTN
  RET

C_DIR:
  LXI D,LINEBUF+2
  INX D
  LDAX D
  CPI 20H
  JZ $-4
  ORA A
  JNZ $+6
  LXI D,ALLFILS
  CALL FS_FNDF
  JC C_DIRNO
C_DIR1: PUSH H
  CALL 0F81BH ;    
  CPI 0FFH    ;         
  JNZ $-5
  LXI B,11
  DAD B
  MOV A,M
  POP H
  ANI 8
  JNZ C_DIR2
  MVI B,8
  CALL PRINTN
  MVI C,' '
  CALL PUTC
  MVI B,3
  CALL PRINTN
  MVI C,' '
  CALL PUTC
  mov A,M
  ani 010H
  jz C_DIR11
  LXI H,NODIR+4 ;_DIR
  CALL PRINT
  jmp C_DIR12
C_DIR11:
  mov A,L
  adi 012H
  mov L,A
  mov A,M
  call PRHEX
  dcx H
  mov A,M
  call PRHEX
C_DIR12:
  LXI H,NEWLINE
  CALL PRINT
C_DIR2: CALL FS_FNDN
  JNC C_DIR1
  RET
C_DIRNO:LXI H,NOFILES
  JMP PRINT

C_CD: LXI H,LINEBUF+1
  INX H
  MOV A,M
  CPI 20H
  JZ $-4
  ORA A
  JNZ C_CD1
  LXI H,NEWLINE
  CALL PRINT
  LXI H,CWD
  JMP PRINT
C_CD1:  XCHG
  CALL FS_CHDIR
  RNC
  LXI H,NODIR
  JMP PRINT

C_X: 
  CALL SD_OFF
#ifdef MX2
  JMP 0F800H
#endif
#ifdef STD
  JMP 0C800H
#endif
#ifdef RK86
  JMP 0F800H
#endif

#ifdef MX2
C_LRD:
  LXI D,LINEBUF+2
  CALL FS_FNDF
  JC C_DIRNO ; no file
  push H ;  HL  FAT   
  mov A,L
  adi 01DH
  mov L,A
  mov A,M
  mov B,A
  dcx H
  mov A,M
  mov C,A ;  BC     
  pop H ;  HL  FAT   
  push B
  push H 
  CALL F_OPEN 
  pop H ;  HL  FAT   
  LXI D,LINEBUF+20H
  push D ;  DE    
  mvi c,7
C_LRD_LOOP1:
  MOV A,M
  STAX D
  INX H
  INX D
  DCR C
  JP C_LRD_LOOP1
  mvi A,20H
  STAX D
  INX D
  mvi c,2
C_LRD_LOOP2:
  MOV A,M
  STAX D
  INX H
  INX D
  DCR C
  JP C_LRD_LOOP2
  XRA A
  STAX D
  pop H ;    
  call 0F848H ;       RAM Disk
  pop B ;  ,  
  push B
  LXI H,0 ;   
  CALL F_READ ; reading
  LXI H,0 ;   
  pop D ;    
  call 0F83FH ;    RAM Disk
  LXI D,LINEBUF+2
C_LRD_LOOP3:
  INX D
  LDAX D
  CPI 0
  JZ C_LRD_LOOP4
  CPI 2CH
  JNZ C_LRD_LOOP3
C_LRD_LOOP4:
  call SET_LAST_SPACE
  call 0c839H ;     DE  ,   HL ( )
  call 0F842H ;   
  LXI H,RWR_OK
  JMP PRINT

C_SRD: 
  LXI D,LINEBUF+2
  CALL FS_FNDF
  JC C_DIRNO ; no file
  push H ;  HL  FAT   
  CALL F_OPEN 
  pop H ;  HL  FAT   
  LXI D,LINEBUF+20H
  push D ;  DE    
  mvi c,7
C_SRD_LOOP1:
  MOV A,M
  STAX D
  INX H
  INX D
  DCR C
  JP C_SRD_LOOP1
  mvi A,20H
  STAX D
  INX D
  mvi c,2
C_SRD_LOOP2:
  MOV A,M
  STAX D
  INX H
  INX D
  DCR C
  JP C_SRD_LOOP2
  XRA A
  STAX D
  pop H ;    
  call 0F848H ;       RAM Disk
  call 0F84BH ;      'call 0F848H'
  LXI H,0
  call 0F84EH ;      HL
;0336   D26A 00 00       v_header_start: .dw 0
;0337   D26C 00 00       v_header_stop:  .dw 0
#define v_header_stop 0D26CH

  LXI D,v_header_stop
  LDAX D
  MOV C,A
  INX D
  LDAX D
  MOV B,A
  LXI H,0
  CALL F_WRITE
  LXI H,RWR_OK
  JMP PRINT
#endif

C_RWR: 
  LXI D,LINEBUF+2
  CALL F_OPEN
  JC C_DIRNO ; no file
  LXI H,LINEBUF+2
C_RWR1: 
  INX H
  MOV A,M
  CPI 0
  JZ C_RWR2
  CPI 2CH
  JNZ C_RWR1
C_RWR2: 
  CALL R65
  LXI H,ERR
  JC PRINT
  LHLD LINEBUF+26  ;size 
  MOV  C,L  ;
  MOV  B,H  ;
  LHLD LINEBUF+24  ;   
  LXI D,LINEBUF
  LDAX D
  CPI 'R'
  JZ C_RWR3
  CALL F_WRITE
  JMP C_RWR4
C_RWR3: 
  CALL F_READ
C_RWR4: 
  LXI H,RWR_OK
  JMP PRINT

;**********************************************
RUNFILE: LXI H,NEWLINE
  CALL PRINT
  LXI H,LINEBUF
  MVI C,'.'
  CALL STRCHR
  JNC RUNF1
  LXI D,DOTRK
  CALL STRCPY
RUNF1:  LXI D,LINEBUF
  CALL F_OPEN
#ifdef MX2
  JNC RD_4B
  LXI H,LINEBUF
  MVI C,'.'
  CALL STRCHR
  LXI D,DOTRKS
  CALL STRCPY
  LXI D,LINEBUF
  CALL F_OPEN ;  RKS 
;  LXI H,NOFILES ;NOTFND
;  JC PRINT
  JC C_DIRNO ; no file
  LXI H,LINEBUF+24
  MVI M,'S'
#else
;  LXI H,NOFILES ;NOTFND
;  JC PRINT
  JC C_DIRNO ; no file
#endif
RD_4B:
  LXI B,4 ;   RK?    /           
  LXI H,LINEBUF
  CALL F_READ
  LXI H,LINEBUF
RUNF2:
  MOV e,M
  INX H
  MOV d,M
  INX H
  MOV A,M
  INX H
  MOV b,M
  SUB E
  MOV c,A
  MOV A,b
  SBB D
  MOV b,A
  INX B
  XCHG
  PUSH H ;  ,  ret  F_READ     
  mov A,H
  call PRHEX
  mov A,L
  call PRHEX
  push B
  MVI C,'-'
  CALL PUTC
  pop B
  mov A,B
  call PRHEX
  mov A,C
  call PRHEX
  CALL F_READ

  LXI H,LINEBUF+24
  MOV A,M
  CPI 'S'
  RNZ ; RKX,   

  LXI D,M2MON
  CALL F_OPEN ;   
;  LXI H,NOFILES ;NOTFND
;  JC PRINT ;     ?
  JNC RUNF3
  pop H
  JMP C_DIRNO ; no file
RUNF3:
  LXI H,0C000H
  LXI B,4096
  CALL F_READ
  JMP 0C000H
;  RET

READLN: LXI H,LINEBUF
READL1: CALL GETC
  CPI 8
  JZ READL3
  CPI 5FH
  JZ READL3
  CPI 18H
  JZ READL4
  MVI M,0
  CPI 0DH
  RZ
  MOV M,A
  INX H
READL2: MOV C,A
  CALL PUTC
  JMP READL1
READL3: MOV A,L
  CPI LINEBUF & 255
  JZ READL1
  MVI C,8
  CALL PUTC
  MVI C,20H
  CALL PUTC
  MVI C,8
  CALL PUTC
  DCX H
  JMP READL1
READL4: MOV A,M
  ORA A
  JZ READL1
  CPI 0DH
  JZ READL1
  INX H
  JMP READL2
;**********************************************
SET_LAST_SPACE:
  INX D
  push D
  mvi c,0AH
R66:
  LDAX D
  CPI 0
  JNZ R68
  MVI A,20H
  STAX D
  JMP R67
R68:
  INX D
  DCR C
  JNZ R66
R67:
  pop D
  ret
;**********************************************
;    
;**********************************************
R65:
  XCHG
#ifdef MX2
  call SET_LAST_SPACE
  call 0c839H ;     DE  ,   HL
  shld LINEBUF+24
  RC
  call 0c839H ;     DE  ,   HL
  shld LINEBUF+26
  RC
  ret
#else
  LXI  H,0
  shld LINEBUF+24
  shld LINEBUF+26
  CALL R7C 
  shld LINEBUF+24
  RC
  CALL R7C 
  shld LINEBUF+26
  RC
  ret
;*********************************************
;   16 
;*********************************************
R7C:  
      LXI  H,0 
      MVI  B,0
R7F:  
      LDAX D
      INX  D
      CPI  00H
      JZ   R7E 
      CPI  2CH
      RZ
      CPI  20H
      JZ   R7F 
      SUI  30H
      JM   R79 
      CPI  0AH
      JM   R80 
      CPI  11H
      JM   R79 
      CPI  17H
      JP   R79 
      SUI  07H
R80:
      MOV  C,A
      DAD  H
      DAD  H
      DAD  H
      DAD  H
      JC   R79 
      DAD  B
      JMP  R7F 
R79:
  STC
R7E:
      RET
#endif

;*********************************************
NEWLINE:DB 0DH,0AH,0
A_DRIVE:DB 0DH,0AH,"A:",0
RWR_OK: DB "OK",0
ERR:    DB "ERR",0
ALLFILS:DB "*",0
NOFILES:DB "NO FILE(S)",0
NODIR:  DB 0DH,0AH,"NO DIR",0

#ifdef STD
DOTRK:  DB ".RKS",0
#endif

#ifdef MX2
DOTRK:  DB ".RKX",0
DOTRKS: DB ".RKS",0
M2MON:  DB "M2_C000.MON",0

#endif

#ifdef RK86
DOTRK:  DB ".RKR",0
#endif

CMDLST: DB "DIR",0
        DW C_DIR
        DB "CD",0
        DW C_CD
        DB "X",0
        DW C_X
        DB "R",0
        DW C_RWR
        DB "W",0
        DW C_RWR
#ifdef MX2
        DB "L",0
        DW C_LRD
        DB "S",0
        DW C_SRD
#endif
        DB 0

#include "sd_proc.inc"
#include "fs_proc.inc"

;EndProg              ;    -   
;#include "sd_bios.inc"  ;BiosEntry:
;#ifdef RK86
; ORG START_ADDR+07ffH
;  nop
;#endif

;#ifdef MX2
;#include "sd_bios.inc"  ;BiosEntry:
;#endif

  END
